/* 1- Realice la localizacin de una cadena en un arreglo usando el algoritmo de bsqueda binaria.La cadena a buscar (clave) debe ingresar como argumento por lnea de comandos. El arreglo de datos debe estar ordenado con anterioridad (requisito de la bsqueda binaria). */
/* Solucin en lenguaje C */

#include <stdio.h>
#include <string.h>

#define N 4

typedef char* t_cadena; /* Tipo cadena de caracteres */
typedef t_cadena t_arreglo_cadenas[N]; /* Tipo arreglo de cadenas */

/* Prototipo */
int buscar(t_cadena clave, t_arreglo_cadenas datos, int n);

/* Programa Principal */
int main(int argc, char *argv[])
{
	t_arreglo_cadenas datos = {"Ana", "Carlos", "Juan", "Mara"};
	int pos;
	if (argc != 2)
	{
		printf("Modo de uso: %s <cadena clave>\n", argv[0]);
		return 1;
	}

	/* Bsqueda */
	pos = buscar(argv[1], datos, N);

	if (pos != N)
	{
		printf("La cadena '%s' se encontr en la posicin %d\n",argv[1], pos);
	}
	else
	{
		printf("La cadena '%s' no pudo encontrarse\n", argv[1]);
	}
	return 0;
}
int buscar(t_cadena clave, t_arreglo_cadenas datos, int n)
{
	int inferior, superior, centro, cmp;

	inferior = 0;
	superior = n-1;

	while ( (inferior <= superior) )
	{
	centro = (inferior + superior) / 2; /* Divisin entera */
	
	cmp = strcmp(clave,datos[centro]);
	if (cmp == 0)
		return centro; /* Encontrado */
	else
		if (cmp < 0)
			superior = centro - 1; /* Buscar en la primera mitad */
		else
			inferior = centro + 1; /* Buscar en la segunda mitad */
	}
	
	/* Si no lo encuentra, retorna 'n' */
	return n;
}