{1- Realice la localizacin de una cadena en un arreglo usando el algoritmo de bsqueda binaria. La cadena a buscar (clave) debe ingresar como argumento por lnea de comandos. El arreglo de datos debe estar ordenado con anterioridad (requisito de la bsqueda binaria).}
{Solucin en lenguaje Pascal}

PROGRAM alg_01_cap05;

CONST N = 4;

TYPE t_cadena = STRING;
TYPE t_arreglo_cadenas = ARRAY[1..N] OF t_cadena;

FUNCTION buscar(clave: t_cadena; datos: t_arreglo_cadenas; n: INTEGER): INTEGER;

VAR 	inferior, superior, centro: INTEGER;
	encontrado: BOOLEAN;

BEGIN
	inferior := 1;
	superior := n;
	encontrado := FALSE;

	WHILE ( (inferior <= superior) AND (NOT encontrado) ) DO
		BEGIN
			centro := (inferior + superior) DIV 2; { Divisin entera }
			IF (clave = datos[centro]) THEN
				encontrado := TRUE { Encontrado }
			ELSE
				IF (clave < datos[centro]) THEN
					superior := centro - 1 { Buscar en la primera mitad }
				ELSE
					inferior := centro + 1; { Buscar en la segunda mitad }
		END;
		IF (encontrado) THEN
			buscar := centro
		ELSE
			{ Si no lo encuentra, retorna 0 }
			buscar := 0
	END;

	VAR datos: t_arreglo_cadenas;
		pos: INTEGER;

{Programa Principal}
BEGIN
	IF (ParamCount <> 1) THEN
		BEGIN
			WRITELN('Modo de uso: ', ParamStr(0), ' <cadena clave>');
			EXIT;
		END;

	datos[1] := 'Ana';
	datos[2] := 'Carlos';
	datos[3] := 'Juan';
	datos[4] := 'Mara';

	{ Bsqueda }
	pos := buscar(ParamStr(1), datos, N);

	IF (pos <> 0) THEN
		WRITELN('La cadena "', ParamStr(1), '" se encontr en la posicin ', pos)
	ELSE
		WRITELN('La cadena "', ParamStr(1), '" no pudo encontrarse');
END.